<script setup lang="ts">
import type { User } from '@/types/Employee'
import { ref, nextTick, computed, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

const intilEmployee: User = {
  id: -1,
  name: '',
  gender: 'Others',
  tel: '',
  username: '',
  password: '',
  role: 'Barista',
  timein: '',
  timeout: '',
  timework: 0
}

const editedEmp = ref<User>(JSON.parse(JSON.stringify(intilEmployee)))

const page = ref(1)
const itemsPerPage = ref<any>(5)
const search = ref<string>('')

const Employees = ref<User[]>([])

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  {
    title: 'Tel.',
    key: 'tel'
  },
  {
    title: 'Position',
    key: 'role'
  },
  { title: '', key: 'actions', sortable: false }
]

let editedIndex = -1
let lastId = 14

function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedEmp.value = Object.assign({}, intilEmployee)
    editedIndex = -1
  })
}

function deleteItemConfirm() {
  Employees.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}

const pageCount = computed(() => {
  return Math.ceil(Employees.value.length / itemsPerPage.value)
})

function deleteItem(item: User) {
  editedIndex = Employees.value.findIndex((p) => p.id === item.id)
  dialogDelete.value = true
}

function editItem(item: User) {
  editedIndex = Employees.value.findIndex((p) => p.id === item.id)
  editedEmp.value = Object.assign({}, item)
  dialog.value = true
}
function initialize() {
  Employees.value = [
    {
      id: 1,
      name: 'Tanakit Wongviroj',
      gender: 'Male',
      tel: '096-384-8697',
      username: 'mark',
      password: 'mark',
      role: 'Manager',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 2,
      name: 'Sivat Ratanawong',
      gender: 'Male',
      tel: '089-012-9131',
      username: 'arm',
      password: 'arm',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 3,
      name: 'Kornnisa Thongiam',
      gender: 'Female',
      tel: '061-510-4124',
      username: 'cake',
      password: 'cake',
      role: 'Manager',
      timein: 'Sun Jan 14 2024 23:02:00 GMT+0700 (Indochina Time)',
      timeout: '',
      timework: 0
    },
    {
      id: 4,
      name: 'Supasita Pochawat',
      gender: 'Female',
      tel: '098-977-1321',
      username: 'john',
      password: 'john',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 5,
      name: 'Chanapa Pumthong',
      gender: 'Female',
      tel: '096-585-2973',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 6,
      name: 'Kwantip Siriworapat',
      gender: 'Male',
      tel: '066-398-0619',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 7,
      name: 'Pimpisut Kaokritsadee',
      gender: 'Female',
      tel: '094-988-5434',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 8,
      name: 'Tanapa Charoenjit',
      gender: 'Female',
      tel: '064-269-7686',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 9,
      name: 'Yanisa Wongsawat',
      gender: 'Female',
      tel: '089-198-8811',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 10,
      name: 'Aphiwit Pluemchit',
      gender: 'Female',
      tel: '097-888-7202',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 11,
      name: 'Chanonthananan Narongsil',
      gender: 'Female',
      tel: '065-872-7990',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 12,
      name: 'Phuttiphong Khantasen',
      gender: 'Female',
      tel: '099-277-9586',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 13,
      name: 'Poomrapee Sadsamai',
      gender: 'Female',
      tel: '086-196-5757',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    }
  ]
}

onMounted(() => {
  initialize()
})

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedEmp.value = Object.assign({}, intilEmployee)
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  if (editedIndex != -1) {
    const formattedNumber = `${editedEmp.value.tel.slice(0, 3)}-${editedEmp.value.tel.slice(3, 6)}-${editedEmp.value.tel.slice(6, 10)}`;
    editedEmp.value.tel = formattedNumber
    Object.assign(Employees.value[editedIndex], editedEmp.value)
  } else {
    editedEmp.value.id = lastId++
    const formattedNumber = `${editedEmp.value.tel.slice(0, 3)}-${editedEmp.value.tel.slice(3, 6)}-${editedEmp.value.tel.slice(6, 10)}`;
    editedEmp.value.tel = formattedNumber
    Employees.value.push(editedEmp.value)
  }
  closeDialog()
}

const formattedEmployees = computed(() => Employees.value.map((Employee) => ({ ...Employee })))

const filteredEmployees = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedEmployees.value.filter((Employee) =>
    Employee.name.toLowerCase().includes(searchLower)
  )
})


</script>

<template>
  <div>

    <div class="ml-5">
      <!-- Data -->
      <div class="text-center">
        <h1 style="text-align: left">EMPLOYEE</h1>
      </div>

      <div>
        <!-- new employee -->
        <div>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <div>
                <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
                  <v-icon icon="mdi mdi-account-plus" size="25px" class="mr-2"></v-icon>
                  <div style="text-align: left">New Employee</div>
                </v-btn>
              </div>
            </template>
            <v-card title="Employee Profile" class="pt-6" style="text-align: center">
              <v-card-title color="blue"><v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="editedEmp.name" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Full Name"
                            placeholder="Enter your name" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="editedEmp.tel" :readonly="loading" :rules="[
                            (v) => !!v || 'Field is Field is required',
                            (v) => (v && v.length === 10) || 'Tel. number must be 10 digits',
                            (v) => /^\d+$/.test(v) || 'Tel. number must contain only digits'
                          ]" class="mb-2" clearable label="Tel." placeholder="Enter your tel."
                            variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="editedEmp.username" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" clearable label="Username"
                            placeholder="Enter your username" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="editedEmp.password" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" clearable label="Password"
                            placeholder="Enter your password" variant="outlined"></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="6">
                          <v-combobox label="Gender" :items="['Male', 'Female', 'Others']" v-model="editedEmp.gender"
                            variant="outlined"></v-combobox>
                        </v-col>

                        <v-col cols="12" sm="6">
                          <v-combobox v-model="editedEmp.role" :items="['Manager', 'Barista']" label="Select your role"
                            :return-object="false" variant="outlined"></v-combobox>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form> </v-card-text></v-card-title>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn style="width: 200px; height: 60px" variant="flat" @click="closeDialog()" class="ms-5"
                  color="red">Cancel</v-btn>
                <v-btn style="width: 200px; height: 60px" variant="flat" color="success" @click="save()" class="ms-10">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="font ma-4 pt-6" style="text-align: center">you want to delete this info?
                🗑️</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                  @click="closeDelete">Cancel</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                  @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>

        <!--title-->
        <v-card-title class="d-flex align-center pe-2">
          <v-icon icon="mdi-account"></v-icon> &nbsp; Employee Info
          <v-spacer></v-spacer>

          <!-- search -->
          <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
            flat hide-details variant="solo-filled"></v-text-field>
        </v-card-title>

        <!-- table -->
        <div>
          <v-data-table v-model:page="page" :headers="headers" :items="filteredEmployees" :items-per-page="itemsPerPage">
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount"></v-pagination>
              </div>
            </template>

            <!-- <template v-slot:item.actions="{ item }"> -->
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
              <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
            </template>
          </v-data-table>
        </div>
      </div>
    </div>

  </div>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: Verdana, sans-serif;
}

div {
  font-family: 'Kanit';
}
</style>
